"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetSessionHistoryDetailedResponseItem = void 0;
/*
 * Copyright (c) 2022-2023 AccelByte Inc. All Rights Reserved
 * This is licensed software from AccelByte Inc, for limitations
 * and restrictions contact your company contract manager.
 */
const zod_1 = require("zod");
const MatchingAlly_js_1 = require("./MatchingAlly.js");
const SessionPlayerHistory_js_1 = require("./SessionPlayerHistory.js");
const SessionPlayerJoining_js_1 = require("./SessionPlayerJoining.js");
exports.GetSessionHistoryDetailedResponseItem = zod_1.z.object({
    _id: zod_1.z.string(),
    channel: zod_1.z.string(),
    client_version: zod_1.z.string(),
    created_at: zod_1.z.string(),
    event_description: zod_1.z.string(),
    event_name: zod_1.z.string(),
    game_mode: zod_1.z.string(),
    joinable: zod_1.z.boolean(),
    joining: zod_1.z.array(SessionPlayerJoining_js_1.SessionPlayerJoining),
    match_id: zod_1.z.string(),
    matching_allies: zod_1.z.array(MatchingAlly_js_1.MatchingAlly),
    namespace: zod_1.z.string(),
    party_id: zod_1.z.string().nullish(),
    players: zod_1.z.array(SessionPlayerHistory_js_1.SessionPlayerHistory),
    region: zod_1.z.string(),
    removed_reason: zod_1.z.string(),
    server_name: zod_1.z.string(),
    session_type: zod_1.z.string(),
    status: zod_1.z.string(),
    user_id: zod_1.z.string()
});
