import { z } from 'zod';
export declare const Server: z.ZodObject<{
    allocation_id: z.ZodString;
    alternate_ips: z.ZodArray<z.ZodString, "many">;
    cpu_limit: z.ZodNumber;
    cpu_request: z.ZodString;
    deployment: z.ZodString;
    game_version: z.ZodString;
    image_version: z.ZodString;
    ip: z.ZodString;
    is_override_game_version: z.ZodBoolean;
    last_update: z.ZodString;
    mem_limit: z.ZodNumber;
    mem_request: z.ZodString;
    namespace: z.ZodString;
    params: z.ZodString;
    pod_name: z.ZodString;
    port: z.ZodNumber;
    ports: z.ZodRecord<z.ZodString, z.ZodNumber>;
    provider: z.ZodString;
    region: z.ZodString;
    session_id: z.ZodString;
    status: z.ZodString;
    status_history: z.ZodArray<z.ZodObject<{
        status: z.ZodString;
        time_stamp: z.ZodString;
    }, "strip", z.ZodTypeAny, {
        status: string;
        time_stamp: string;
    }, {
        status: string;
        time_stamp: string;
    }>, "many">;
}, "strip", z.ZodTypeAny, {
    params: string;
    status: string;
    game_version: string;
    namespace: string;
    deployment: string;
    region: string;
    allocation_id: string;
    alternate_ips: string[];
    cpu_limit: number;
    cpu_request: string;
    image_version: string;
    ip: string;
    is_override_game_version: boolean;
    last_update: string;
    mem_limit: number;
    mem_request: string;
    pod_name: string;
    port: number;
    ports: Record<string, number>;
    provider: string;
    session_id: string;
    status_history: {
        status: string;
        time_stamp: string;
    }[];
}, {
    params: string;
    status: string;
    game_version: string;
    namespace: string;
    deployment: string;
    region: string;
    allocation_id: string;
    alternate_ips: string[];
    cpu_limit: number;
    cpu_request: string;
    image_version: string;
    ip: string;
    is_override_game_version: boolean;
    last_update: string;
    mem_limit: number;
    mem_request: string;
    pod_name: string;
    port: number;
    ports: Record<string, number>;
    provider: string;
    session_id: string;
    status_history: {
        status: string;
        time_stamp: string;
    }[];
}>;
export interface Server extends z.TypeOf<typeof Server> {
}
